package ${package.Controller};

import net.wanji.common.framework.Constants;
import net.wanji.common.framework.dubbointerface.BaseDubboInterface;
import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.common.framework.rest.AbstractRestServer;
import net.wanji.common.framework.dubbointerface.BaseDubboInterface;
import net.wanji.common.framework.exception.DubboProviderException;
import net.wanji.common.framework.i18n.I18nResourceBundle;
import net.wanji.common.framework.rest.AbstractRestServer;
import net.wanji.common.framework.rest.impl.AbstractRestServerImpl;
import ${package.Service}.${entity}Service;
import ${package.Entity}.${entity};
import net.wanji.common.framework.rest.Page;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiImplicitParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Maps;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import javax.ws.rs.core.MediaType;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * ${table.comment!} 接口API
 * </p>
 *  @version 1.0
 * @author ${author}
 * @Date ${date}
 */
@RestController
@Slf4j
@RequestMapping("/<#if controllerMappingHyphenStyle??>${controllerMappingHyphen}<#else>${table.entityPath}</#if>")
@Api(value="${entity}Controller", description="${table.comment!}接口", tags = "${table.comment}")
public class ${entity}Controller extends AbstractRestServerImpl<${entity}> implements AbstractRestServer<${entity}>{

    @Autowired
    private ${table.serviceName} ${table.serviceName?uncap_first};

    @Override
    public ${table.serviceName} getBaseDubboInterface() {
        return this.${table.serviceName?uncap_first};
    }


    /**
    * 获取所有${table.comment!}记录
    *
    * @return JsonViewObject
    */
    @ApiOperation(value = "${table.comment!}-获取所有记录", notes = "获取所有${table.comment!}记录", response = ${entity}.class, produces = MediaType.APPLICATION_JSON,hidden = true)
    @GetMapping(value = "/byAll", produces = MediaType.APPLICATION_JSON)
    @Override
    public JsonViewObject getAll() {
        JsonViewObject jsonView = JsonViewObject.newInstance();
        long start=System.currentTimeMillis();

        try {
            List<${entity}> list = this.getBaseDubboInterface().findAll();
            jsonView.success(list);
        } catch (DubboProviderException e) {
            jsonView.fail(I18nResourceBundle.getConstants("GET_FAILED_MSG"));
            log.error("{} getAll error", this.getClass().getSimpleName(), e);
        }
            return jsonView;
    }


    /**
    * 根据id查询${table.comment!}记录
    *
    * @param id
    * @return JsonViewObject
    */
    @ApiOperation(value = "${table.comment!}-根据id查询记录", notes = "根据id查询${table.comment!}记录", response = ${entity}.class, produces = MediaType.APPLICATION_JSON,hidden = true)
    @GetMapping(value = "/{id}", produces = MediaType.APPLICATION_JSON)
    @Override
    public JsonViewObject getById(@PathVariable String id) {
        JsonViewObject jsonView = JsonViewObject.newInstance();
        long start=System.currentTimeMillis();

        try {
            ${entity} entity = this.getBaseDubboInterface().findById(id);
            jsonView.success(entity);
        } catch (DubboProviderException e) {
            jsonView.fail(I18nResourceBundle.getConstants("GET_FAILED_MSG"));
            log.error("AbstractRestServerImpl getById error, id:{}", id, e);
        }
        return jsonView;
    }

    @ApiOperation(value = "${table.comment!}-根据条件查询记录", notes = "根据条件查询记录", consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/byCondition", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @Override
    public JsonViewObject getByWhere(@RequestBody ${entity} entity) {
        return  super.getByWhere(entity);
    }

    @ApiOperation(value = "${table.comment!}-根据条件分页查询记录", notes = "根据条件分页查询记录",  produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON,hidden = true)
    @PostMapping(value = "/byPage", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @ResponseBody
    public  JsonViewObject getPage(@RequestBody Page<${entity}> page){
        return  super.getPage(page);
    }


    /**
    * 根据id删除
    *
    * @param ids
    * @return JsonViewObject
    */
    @ApiOperation(value = "${table.comment!}-根据多个id删除记录", notes = "根据多个id删除记录", response = JsonViewObject.class, produces = MediaType.APPLICATION_JSON ,hidden = true)
    @ApiImplicitParams(value = {
    @ApiImplicitParam(paramType = "query", name = "ids", dataType = "String", required = true, value = "多个记录id，用逗号分隔", example = "1,2")
    })
    @GetMapping(value = "/deleting", produces = MediaType.APPLICATION_JSON)
    public JsonViewObject deleteByIds(String ids) {
         return  super.deleteByIds(ids);
    }

    /**
    * 新建记录
    *
    * @param entity
    * @return JsonViewObject
    */
    @ApiOperation(value = "${table.comment!}-新建记录", notes = "新建记录", response = JsonViewObject.class, produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON,hidden = true)
    @PostMapping(value = "/creating", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    public JsonViewObject save( @RequestBody ${entity} entity){
        return  super.save(entity);
    }

    /**
    * 修改记录
    *
    * @param entity
    * @return
    */
    @ApiOperation(value = "${table.comment!}-修改记录", notes = "修改记录", response = JsonViewObject.class, produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON,hidden = true)
    @PostMapping(value = "/updating", produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    public  JsonViewObject update(@RequestBody ${entity} entity){
        return  super.update(entity);
    }

}
